#include "texture.h"

#include <fstream>

using namespace std;

void Texture::LoadFromRGB(std::string filename, int width, int height)
{
	// Wipe out the old one.
	Delete();
	
	char *buf;
	size_t bufsize;
	bufsize = (width * height) * 3;
	ifstream in(filename.c_str(), ios::binary);
	if (! in.good()) {
		throw "Unable to open file reading texture";
	}
	buf = new char[bufsize];
	in.read(buf, bufsize);
	glGenTextures(1, &texnum);
	glBindTexture(GL_TEXTURE_2D, texnum);
	// Not sure what these do, but I like them.
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, width, height,
               0, GL_RGB, GL_UNSIGNED_BYTE, buf);
	delete[] buf;
}
void Texture::LoadFromRGBA(std::string filename, int width, int height)
{
	// Wipe out the old one.
	Delete();
	
	char *buf;
	size_t bufsize;
	bufsize = (width * height) * 4;
	ifstream in(filename.c_str(), ios::binary);
	if (! in.good()) {
		throw "Unable to open file reading texture";
	}
	buf = new char[bufsize];
	in.read(buf, bufsize);
	glGenTextures(1, &texnum);
	glBindTexture(GL_TEXTURE_2D, texnum);
	// Not sure what these do, but I like them.
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, width, height,
               0, GL_RGBA, GL_UNSIGNED_BYTE, buf);
	delete[] buf;
}

void Texture::Delete()
{
	if (texnum != 0) {
		glDeleteTextures(1, &texnum);
		texnum = 0;
	}
}

